//Rope shape
datablock StaticShapeData(HataCylinder2Shape)
{
	shapeFile = "./hatacyl2.dts";
};

//reel sound
// datablock AudioProfile(ReelSound)
// {
//    filename    = "./pull.wav";
//    description = AudioClosest3d;
//    preload = true;
// };

//Hook Trail Particle
datablock ParticleData(GrapplingHookTrailParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed			 = 0;
	colors[0]     = "0.67 0.53 0.44 1";
	colors[1]     = "0.67 0.53 0.44 0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(GrapplingHookTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	particles = "GrapplingHookTrailParticle";

	uiName = "";
};

//Hit Explosion
datablock ExplosionData(GrapplingHookExplosion : HammerExplosion)
{
	soundProfile = hammerhitsound;
};

//Hook Projectile
datablock ProjectileData(GrapplingHookProjectile)
{
	projectileShapeName = "./grapple rope head.dts";
	directDamage        = 0;
	directDamageType    = $DamageType::Direct;
	particleEmitter     = GrapplingHookTrailEmitter;
	explosion           = GrapplingHookExplosion;

	muzzleVelocity      = 100;
	velInheritFactor    = 0;

	armingDelay         = 0;
	lifetime            = 250;
	fadeDelay           = 250;
	gravityMod 			= 1;
	isBallistic         = true;

	uiName = "";
};


//Item
datablock ItemData(GrapplingHookItem : GunItem)
{
	shapeFile = "./grapple rope.dts";
	uiName = "Grapple Hook";
	iconName = "";

	doColorShift = true;
	colorShiftColor = "0.2 0.2 0.2 1";

	image = GrapplingHookImage;
	canDrop = true;
};


//Empty Image
datablock ShapeBaseImageData(GrapplingHookEmptyImage)
{
	shapeFile = "./grapple rope only.dts";
	mountPoint = 1;
	emap = true;

	className = "WeaponImage";
	item = GrapplingHookItem;
	isGrapplingHook = true;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "Ready";

	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2]                    = "Fire";
	statetimeoutValue[2]			= 1.0;
	stateScript[2]					= "onFire";
	stateTransitionOnTimeout[2]		= "Ready";
	stateWaitForTimeout[2]			= true;
};
//Main Image
datablock ShapeBaseImageData(GrapplingHookImage : GrapplingHookEmptyImage)
{
	shapeFile = GrapplingHookItem.shapeFile;
	mountPoint = 0;
//	eyeOffset = 0;
	offset = "0 0 0"; //"0 0 0.1";
	rotation = eulerToMatrix("0 0 0"); //("-90 0 -16");
	colorShiftColor = GrapplingHookItem.colorShiftColor;
	doColorShift = false;
};
//Mounting
function GrapplingHookImage::onMount(%this,%obj,%slot)
{
	if (%obj.isHookGrappling) {
		%obj.unMountImage(0);
		%obj.mountImage(GrapplingHookEmptyImage, 0);
		return;
	}
	Parent::onMount(%this,%obj,%slot);
	%obj.playthread(1,armreadyright);
}
function GrapplingHookImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
}
//Throw the Hook
function GrapplingHookImage::onFire(%this,%obj,%slot)
{
	GrapplingHookToggle(%obj,%this);
}
function GrapplingHookEmptyImage::onFire(%this,%obj,%slot)
{
	GrapplingHookRelease(%obj, "onfire");
	%obj.unMountImage(0);
	%obj.mountImage(GrapplingHookImage, 0);
}
//On Hook hit something
function GrapplingHookProjectile::onCollision(%this,%proj,%col,%fade,%pos,%normal)
{
	%obj = %proj.sourceObject;
	Parent::onCollision(%this,%proj,%col,%fade,%pos,%normal);
	GrapplingHookLatchOn(%obj,%col,%pos);

	if (%col.getClassName() $= "fxDTSBrick") {
		%col.onGrapple(%obj, %obj.client);
	}
	%obj.grappledTo = %col;
	%col.grappleObj[%col.grappleCount + 0] = %obj;
	%col.grappleCount++;
}

// registerInputEvent("fxDTSBrick", "onGrapple", "Self fxDTSBrick" TAB "Client GameConnection" TAB "Player Player" TAB "Minigame Minigame");

function fxDTSBrick::onGrapple(%b, %pl, %cl) {
	$InputTarget_["Self"] = %b;
	$InputTarget_["Player"] = %pl;
	$InputTarget_["Client"] = %cl;
	$InputTarget_["Minigame"] = %cl.minigame;
	
	%b.processInputEvent("onGrapple", %cl);
}

// registerInputEvent("fxDTSBrick", "onGrappleDetach", "Self fxDTSBrick" TAB "Client GameConnection" TAB "Player Player" TAB "Minigame Minigame");

function fxDTSBrick::onGrappleDetach(%b, %pl, %cl) {
	$InputTarget_["Self"] = %b;
	$InputTarget_["Player"] = %pl;
	$InputTarget_["Client"] = %cl;
	$InputTarget_["Minigame"] = %cl.minigame;
	
	%b.processInputEvent("onGrappleDetach", %cl);
}

// registerOutputEvent("fxDTSBrick", "detachGrapples", "", 1);

function fxDTSBrick::detachGrapples(%b, %cl) {
	for (%i = 0; %i < %b.grappleCount; %i++) {
		GrapplingHookRelease(%b.grappleObj[%i], "detachGrapples: " @ %b);
	}
}

if(!isObject($GrappleList))
{
	$GrappleList = new SimGroup()
	{
		class = "GrappleList";
	};
}

//Grappling Hook Global Silent Loop
function GrapplingHookGlobalSilentLoop()
{
	cancel($GrapplingHook::SilentSchedule);
	for(%i=0;%i<$GrappleList.getCount();%i++)
	{
		%obj = $GrappleList.getObject(%i);
		if(!isObject(%obj) || %obj.getState() $= "Dead")
			continue;
		%wep = %obj.getMountedImage(0);
		if((!isObject(%wep) || !%wep.isGrapplingHook) && !%obj.isHookGrappling)
		{
			$GrappleList.remove(%obj); //Remove player in this situation also
			continue;
		}
		GrapplingHookHangLoop(%obj);
		%isGrapplingHooker = true;
	}

	if(%isGrapplingHooker)
	{
		$GrapplingHook::SilentSchedule = schedule(10,0,GrapplingHookGlobalSilentLoop);
		$GrapplingHook::SilentStarted = true;
	}
	else
		$GrapplingHook::SilentStarted = false;
}

//Toggle Grapple
function GrapplingHookToggle(%obj,%this)
{
	if(!%obj.isHookGrappling)
		GrapplingHookFire(%obj,%this);
	else
		GrapplingHookRelease(%obj, "toggle");
}

//Shoot out initial Grappling Hook
function GrapplingHookFire(%obj,%this)
{
	%obj.playthread(3,activate);
	%obj.playthread(1,shiftaway);
	if(%this.getName() !$= "GrapplingHookEmptyImage")
		%obj.mountImage(GrapplingHookEmptyImage,0);

	%lifetime = 500; //must match projectileData lifetime
	%projectile = GrapplingHookProjectile;
	%speed = %projectile.muzzleVelocity;
	%len = %speed*%lifetime/1000; //Predicted end point
	%muzzle = %obj.getMuzzlePoint(0);
	%vector = %obj.getMuzzleVector(0);
	%eye = %obj.getHackPosition();
//	%hPos = GrapplingHookRaycast(%obj,%len,%eye); //Position from raycast
	if(%hPos !$= "")
	{
		%sub = vectorSub(%hPos,%muzzle);
		if(vectorDot(%sub,%vector) > 0.5) //Make sure Sub isn't too short
			%vector = vectorNormalize(%sub); //correct muzzle vector
	}
	%velocity = vectorScale(%vector,%speed);
	%p = new (Projectile)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %muzzle;
		sourceObject = %obj;
		client = %obj.client;
	};MissionCleanup.add(%p);
	cancel(%obj.GrapHookReturn);
	%obj.GrapHookReturn = schedule(%lifetime,0,GrapplingHookRelease,%obj, "fire"); //Return Grappling Hook after lifetime
//	echo("len =" SPC %len SPC "  muzzle vel =" SPC %speed SPC "  vector =" SPC %vector SPC "  velocity =" SPC %velocity);
}



//Return Grappling Hook (if miss)
function GrapplingHookRelease(%obj, %v)
{
	// if (%obj == fcn(Conan).player) {
	// 	talk("release: " @ %v);
	// }
	if (isObject(%obj.grappledTo) && %obj.grappledTo.getClassName() $= "fxDTSBrick") {
		%obj.grappledTo.onGrappleDetach(%obj, %obj.client);
	}
	//%id = %obj.grappledTo.grappleID[%obj];
	%obj.grappledTo.grappleCount--;
	%obj.grappledTo.grappledObj[%obj.grappledTo.grappleCount] = "";
	%obj.grappledTo = "";

	%wep = %obj.getMountedImage(0);
	if(isObject(%wep) && %wep.getName() $= "GrapplingHookEmptyImage")
	{
		%obj.mountImage(GrapplingHookImage,0);
		%obj.playthread(1,armreadyright);
	}
	if(%obj.isHookGrappling)
		serverPlay3D(wrenchmisssound,%obj.getMuzzlePoint(0));
	%obj.isHookGrappling = false;
	%obj.isZiplining = false;
//	%obj.isPhysJumpOverride = false;
}

//Latch on to object
function GrapplingHookLatchOn(%obj,%col,%pos)
{
	cancel(%obj.GrapHookReturn);
	%obj.GrapplingHookPos = "";
	%obj.GrapplingHookTarget = "";
	if(%col.getType() & $Typemasks::PlayerObjectType || %col.getType() & $Typemasks::VehicleObjectType)
		%obj.GrapplingHookTarget = %col;
	else
		%obj.GrapplingHookPos = %pos;
	%obj.isHookGrappling = true;
	%obj.isHookGrappleStart = true;
//	%obj.isPhysJumpOverride = true;
	schedule(30,0,eval,%obj@".isHookGrappleStart = false;");
	$GrappleList.add(%obj); //Grappled players list
	if(!$GrapplingHook::SilentStarted)
		schedule(10,0,GrapplingHookGlobalSilentLoop);
}

function GrapplingHookHangLoop(%obj)
{
	%col = %obj.GrapplingHookTarget;	
	%pos = %obj.GrapplingHookPos;
	//check if mounted to col
	if (isObject(%col) && %obj.isMounted() && %obj.getObjectMount() == %col) {
		GrapplingHookRopeCheck(%obj,%pos,%start); //Do rope FX
		return;
	}

	//add col's velocity
	if(isObject(%col))
	{
		if(%col.getType() & $Typemasks::PlayerObjectType && $Pref::GrapplingHook::onPlayers)
		{
			%pos = %col.getHackPosition(); //torso of player
			if(isObject(%vehicle = %col.getObjectMount()))
				%col = %vehicle;
		}
		if(%col.getType() & $Typemasks::VehicleObjectType && $Pref::GrapplingHook::onVehicles)
			%pos = %col.getWorldBoxCenter(); //middle of vehicle
		%vAdd = %col.getVelocity(); //Add col's velocity
	}
	if(%pos $= "" || !%obj.isHookGrappling)
		return;
	%hack = %obj.getHackPosition(); //torso
	%sub = vectorSub(%hack,%pos); //vector from hand to col
	if(%obj.isHookGrappleStart)
	{
		%obj.isHookGrappleStart = false; //already set rope length
		%obj.HookGrappleLength = vectorLen(%sub); //maintain rope length
		%start = true;
	}
	if(%obj.isGrapJumping && %obj.HookGrappleLength > 0.5) { //If holding Jump key
		%obj.HookGrappleLength = %obj.HookGrappleLength-0.03; //shrink the rope
		if (getSimTime() - %obj.lastPlayedSound > 120){
			serverPlay3D(wrenchHitSound, %obj.getPosition());
			%obj.lastPlayedSound = getSimTime();
		}
	}
	else if(%obj.isGrapCrouching && %obj.HookGrappleLength < 20) {//Otherwise if holding Crouch key
		%obj.HookGrappleLength = %obj.HookGrappleLength+0.03; //stretch the rope
		if (getSimTime() - %obj.lastPlayedSound > 120){
			serverPlay3D(wrenchHitSound, %obj.getPosition());
			%obj.lastPlayedSound = getSimTime();
		}
	}
	%speed = 2; //how fast to correct hang position
	%length = %obj.HookGrappleLength; //length of the rope
	%nrm = vectorNormalize(%sub); //normalized %sub
	%inv = vectorScale(%nrm,-1); //invert normalized vector
	%scale = vectorScale(%nrm,%length); //ideal length to player
	%point = vectorAdd(%scale,%pos); //ideal player position

	if (%obj.isZiplining) {
		if (%length < 1) {
			%pl.isHookGrappling = false;
			%pl.isZiplining = 0;
		}
		%vel = "0 0 1";
	} else
		%vel = %obj.getVelocity(); //player velocity
	%dif = vectorSub(%point,%hack); //vector from hand to ideal hang position
	%mov = vectorScale(%dif,%speed); //new position fixing velocity
	%mov = vectorAdd(%mov,%vAdd); //new position + col's velocity
	%len = vectorLen(%sub); //length from col to player

	%iHor = getWords(%inv,0,1) SPC 0; //get %inv's horizontal component
	%iFwd = vectorNormalize(%iHor); //find %inv's forward vector

	%iX = getWord(%inv,0); //x component of %inv
	%iY = getWord(%inv,1); //y component of %inv
	%iZ = getWord(%inv,2); //z component of %inv

	%rvec = vectorCross(%iFwd,"0 0 1"); //relative x vector
	%uvec = vectorCross(%rvec,%inv); //relative z vector
	%dotX = vectorDot(%vel,%rvec); //relative x velocity
	%dotZ = vectorDot(%vel,%uvec); //relative z velocity
	%dotY = vectorDot(%vel,%inv); //relative y velocity
	if(%len > %length) //Allow full velocity when closer to col
		%dotY = vectorDot(%mov,%inv); //substitute y add for velocity

	%rAdd = %dotX SPC %dotY SPC %dotZ; //relative velocity to set
	%final = vectorRotateVector(%rAdd,%iX*(-1) SPC %iY SPC %iZ); //rotate relative velocity to match rope vector

	if(!isObject(%mount = %obj.getObjectMount())) //If not in a vehicle
		%obj.setVelocity(%final); //set final velocity
	else //otherwise
		%mount.setVelocity(%final); //set vehicle's final velocity
	GrapplingHookRopeCheck(%obj,%pos,%start); //Do rope FX
//	centerPrint(%obj.client,"<font:impact:30><color:FFF200><just:center>Grapple Hang Loop<color:CCCCCC><br>" @ "velocity =" SPC %vel @ "<br>fix =" SPC %fix @ "<br>final =" SPC %final,10);
}

//Rope FX Check
function GrapplingHookRopeCheck(%obj,%pos,%start)
{
	if(%start || !isObject(%obj.GHRope))
		GrapplingHookRopeCreate(%obj);
	GrapplingHookRopeUpdate(%obj,%pos);
}
//Create Rope
function GrapplingHookRopeCreate(%obj)
{
	if(isObject(%obj.GHRope))
		%obj.GHRope.delete();

	%obj.GHRope = new StaticShape()
	{
		dataBlock = HataCylinder2Shape;
	};MissionCleanup.add(%obj.GHRope);
	%obj.GHRope.setNodeColor("ALL","0.67 0.53 0.44 1");
}
//Manipulate Rope
function GrapplingHookRopeUpdate(%obj,%pos)
{
	if (%obj.getClassName() !$= "Player")
		%hand = %obj.getmuzzlePoint(2); //neck point
	else
		%hand = %obj.getMuzzlePoint(1); //grab point
	%size = 0.2; //scale of rope

	%vector = vectorNormalize(vectorSub(%pos,%hand));
	%relative = "0 1 0";

	%xyz = vectorNormalize(vectorCross(%relative,%vector));
	%u = mACos(vectorDot(%relative,%vector)) * -1;

	%obj.GHRope.setTransform(vectorScale(vectorAdd(%hand,%pos),0.5) SPC %xyz SPC %u);
	%obj.GHRope.setScale(%size SPC vectorDist(%hand,%pos) * 2 SPC %size);

	cancel(%obj.GHRopeKill);
	%obj.GHRopeKill = schedule(100,0,GrapplingHookRopeKill,%obj.GHRope);
}
//Kill Rope
function GrapplingHookRopeKill(%rope)
{
	if(isObject(%rope))
		%rope.delete();
}

package GrapplingHook
{
	//on Death
	function Armor::onDisabled(%data,%obj,%enabled)
	{
		GrapplingHookRopeKill(%obj.GHRope);
		Parent::onDisabled(%data,%obj,%enabled);
	}
	//on Leave
	function GameConnection::OnClientLeaveGame(%client)
	{
		if(isObject(%client.player))
			GrapplingHookRopeKill(%client.player.GHRope);
		Parent::OnClientLeaveGame(%client);
	}
	function Armor::onTrigger(%data,%obj,%slot,%val)
	{
		if(%slot == 2)
			%obj.isGrapJumping = %val;
		if(%slot == 3)
			%obj.isGrapCrouching = %val;
		Parent::onTrigger(%data,%obj,%slot,%val);
	}
};activatePackage(GrapplingHook);

//Raycast
function GrapplingHookRaycast(%obj,%len,%pos)
{
	%vec = %obj.getMuzzleVector(0);
	%beam = vectorScale(%vec,%len);
	%end = vectorAdd(%pos,%beam);
	%masks = $TypeMasks::PlayerObjectType | $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRayCast(%pos,%end,%masks,%obj);
	%col = firstWord(%ray);
	if(isObject(%col))
		%hitLoc = posFromRaycast(%ray);
	return %hitLoc;
}

//Boodals Vector Manipulation
function vectorRotateVector(%vec1,%vec2)
{
	return vectorRotateAxis(%vec1,vectorToAxis(%vec2));
}
function vectorToAxis(%vec)
{
	return eulerToAxis(vectorToEuler(%vec));
}
function vectorToEuler(%vec)
{
	%vec = vectorNormalize(%vec);
	%yaw   = mRadToDeg(mATan(getWord(%vec,0),getWord(%vec,1)));
	%pitch = mRadToDeg(mASin(getWord(%vec,2)));
	return %pitch SPC 0 SPC %yaw;
}
function vectorRotateAxis(%vec,%axis)
{
	%u["x"] = getword(%axis,0);
	%u["y"] = getword(%axis,1);
	%u["z"] = getword(%axis,2);

	%angl = getword(%axis,3) * -1;
	%cos = mcos(%angl);
	%sin = msin(%angl);

	%a[1,1] = %cos + (%u["x"] * %u["x"] * (1 - %cos));
	%a[1,2] = (%u["x"] * %u["y"] * (1 - %cos)) - (%u["z"] * %sin);
	%a[1,3] = (%u["x"] * %u["z"] * (1 - %cos)) + (%u["y"] * %sin);

	%a[2,1] = (%u["y"] * %u["x"] * (1 - %cos)) + (%u["z"] * %sin);
	%a[2,2] = %cos + (%u["y"] * %u["y"] * (1 - %cos));
	%a[2,3] = (%u["y"] * %u["z"] * (1 - %cos)) - (%u["x"] * %sin);

	%a[3,1] = (%u["z"] * %u["x"] * (1 - %cos)) - (%u["y"] * %sin);
	%a[3,2] = (%u["z"] * %u["y"] * (1 - %cos)) + (%u["x"] * %sin);
	%a[3,3] = %cos + (%u["z"] * %u["z"] * (1 - %cos));

	%x = getWord(%vec, 0);
	%y = getWord(%vec, 1);
	%z = getWord(%vec, 2);

	%newx = (%a[1,1] * %x) + (%a[1,2] * %y) + (%a[1,3] * %z);
	%newy = (%a[2,1] * %x) + (%a[2,2] * %y) + (%a[2,3] * %z);
	%newz = (%a[3,1] * %x) + (%a[3,2] * %y) + (%a[3,3] * %z);

	%pos = %newx SPC %newy SPC %newz;
	return %pos;
}
//Trader's code
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}